; Inclusion
(asdf:oos 'asdf:load-op 'cl-opengl)
(asdf:oos 'asdf:load-op 'cl-glu)
(asdf:oos 'asdf:load-op 'cl-glut)

; my arcball implementation
(asdf:oos 'asdf:load-op 'cl-arcball)


;;;; lisp opengl window

;; Window Initialization
(glut:init)
(glut:init-window-size 500 500)
(glut:init-window-position 100 100)
(defvar *lispwindow* (glut:create-window "lispywindow"))

;; arcball initialization
(defvar *ball* (arcball:make-arcball))
(arcball:setbounds *ball* 500 500)

;; Remembers if the shift button is pressed.
(defvar *shift* nil)

;; this variable remembers the window zoom
(defvar *zoom* 5.0)

;;;; Initialize OpenGL
;; viewport stuff
(gl:viewport 0 0 500 500)
(gl:matrix-mode :projection)
(gl:load-identity)
(glu:perspective 50 1.0 0.5 20)
(gl:matrix-mode :modelview)
(gl:load-identity)

;;lighting and color
(gl:clear-color 0 0 0 0)
(gl:shade-model :smooth)
(gl:clear-depth 1.0)
(gl:disable :dither)
(gl:color-material :front-and-back :ambient-and-diffuse)
(gl:enable :lighting :light0 :color-material :depth-test)
; initialize light 0
(gl:light :light0 :position '(1 1 1 0))
(gl:light :light0 :diffuse '(1 1 1 0))

;(gl:hint :perspective-correction :nicest) ; no worky

;; Callback Initialization
(cffi:defcallback display :void ()
  (gl:clear :color-buffer-bit :depth-buffer-bit)

  (gl:push-matrix)
    (gl:load-identity) ; clear the matrix
    (gl:translate 0 0 (- *zoom*)) ; zoom out
    (gl:mult-matrix (arcball:matrix *ball*)) ;use arcball to rotate scene
    (gl:light :light0 :position '(1 1 1 0))

    (gl:color 1 0 0)
    (glut:solid-sphere 1.0 30 30)
    
    (gl:push-matrix)
      (gl:translate 1 1 1)
      (gl:color 0 1 1)
      (glut:solid-sphere 0.1 20 20)
    (gl:pop-matrix)
    
    (gl:color 1 1 1)
    (gl:begin :lines)
      (gl:vertex 0 0 0)
      (gl:vertex 1 1 1)
    (gl:end)
  (gl:pop-matrix)

  (gl:flush))

;; Define callbacks
(cffi:defcallback idle :void () (glut:post-redisplay))

(cffi:defcallback reshape :void ((width :int) (height :int))
  (arcball:setbounds *ball* width height)
  (gl:viewport 0 0 width height)
  (gl:matrix-mode :projection)
  (gl:load-identity)
  (glu:perspective 50 (/ width height) 0.5 20)
  (gl:matrix-mode :modelview)
  (gl:load-identity))
  
(cffi:defcallback keyboard :void ((key :char) (x :int) (y :int))
  (declare (ignore x y))
  (when (eql key 27)
    (glut:destroy-window (cffi:convert-to-foreign *lispwindow* :int))
    (quit)))

(cffi:defcallback mouseclick :void ((button :int) (state :int) (x :int) (y :int))
  (when (and (eql state 0) (eql button 0)) ;down, left-button
    (arcball:click *ball* x y)))

(cffi:defcallback mousedrag :void ((x :int) (y :int)) (arcball:drag *ball* x y))

;; Register Callbacks	
(glut:display-func (cffi:callback display))
(glut:idle-func (cffi:callback idle))
(glut:reshape-func (cffi:callback reshape))
(glut:keyboard-func (cffi:callback keyboard))
(glut:mouse-func (cffi:callback mouseclick))
(glut:motion-func (cffi:callback mousedrag))

; Execution
(glut:main-loop)

